Index: LMDZ5/branches/LMDZ6_rc0/libf/bibio/wxios.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/bibio/wxios.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/bibio/wxios.F90	(revision 2381)
@@ -191,5 +191,5 @@
                 CALL xios_set_context_attr_hdl(g_ctx, calendar_type= "NoLeap")
                 IF (prt_level >= 10) WRITE(lunout,*) 'wxios_set_cal: Calendrier terrestre a 365 jours/an'
-            CASE('earth_366d')
+            CASE('gregorian')
                 CALL xios_set_context_attr_hdl(g_ctx, calendar_type= "Gregorian")
                 IF (prt_level >= 10) WRITE(lunout,*) 'wxios_set_cal: Calendrier gregorien'
Index: LMDZ5/branches/LMDZ6_rc0/libf/dyn3d_common/infotrac.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/dyn3d_common/infotrac.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/dyn3d_common/infotrac.F90	(revision 2381)
@@ -29,4 +29,5 @@
 
   CHARACTER(len=4),SAVE :: type_trac
+  CHARACTER(len=8),DIMENSION(:),ALLOCATABLE, SAVE :: solsym
  
 CONTAINS
@@ -62,5 +63,4 @@
 
     CHARACTER(len=15), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
-    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tracnam ! name from INCA
     CHARACTER(len=3), DIMENSION(30) :: descrq
     CHARACTER(len=1), DIMENSION(3)  :: txts
@@ -94,5 +94,5 @@
        WRITE(lunout,*) 'You have choosen to couple with INCA chemestry model : type_trac=', &
             type_trac,' config_inca=',config_inca
-       IF (config_inca/='aero' .AND. config_inca/='chem') THEN
+       IF (config_inca/='aero' .AND. config_inca/='aeNP' .AND. config_inca/='chem') THEN
           WRITE(lunout,*) 'Incoherence between type_trac and config_inca. Model stops. Modify run.def'
           CALL abort_gcm('infotrac_init','Incoherence between type_trac and config_inca',1)
@@ -172,5 +172,5 @@
 !
     ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
-    ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), solsym(nbtr))
     conv_flg(:) = 1 ! convection activated for all tracers
     pbl_flg(:)  = 1 ! boundary layer activated for all tracers
@@ -254,5 +254,5 @@
             conv_flg, &
             pbl_flg,  &
-            tracnam)
+            solsym)
 #endif
        tnom_0(1)='H2Ov'
@@ -260,5 +260,5 @@
 
        DO iq =3,nqtrue
-          tnom_0(iq)=tracnam(iq-2)
+          tnom_0(iq)=solsym(iq-2)
        END DO
        nqo = 2
@@ -394,5 +394,5 @@
 !
     DEALLOCATE(tnom_0, hadv, vadv)
-    DEALLOCATE(tracnam)
+
 
   END SUBROUTINE infotrac_init
Index: LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/gcm.F
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/gcm.F	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/gcm.F	(revision 2381)
@@ -240,5 +240,5 @@
      $        iphysiq,day_step,nday, 
      $        nbsrf, is_oce,is_sic,
-     $        is_ter,is_lic)
+     $        is_ter,is_lic, calend)
 
          call init_inca_para(
Index: LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/leapfrog_loc.F	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/dyn3dmem/leapfrog_loc.F	(revision 2381)
@@ -1397,56 +1397,63 @@
       IF (itau==itaumax) then
 c$OMP MASTER
-            call allgather_timer_average
-      call barrier
-      if (mpi_rank==0) then
-        
-        print *,'*********************************'
-        print *,'******    TIMER CALDYN     ******'
-        do i=0,mpi_size-1
-          print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
-     &            '  : temps moyen :',
-     &             timer_average(jj_nb_caldyn(i),timer_caldyn,i)
-        enddo
-      
-        print *,'*********************************'
-        print *,'******    TIMER VANLEER    ******'
-        do i=0,mpi_size-1
-          print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
-     &            '  : temps moyen :',
-     &             timer_average(jj_nb_vanleer(i),timer_vanleer,i)
-        enddo
-      
-        print *,'*********************************'
-        print *,'******    TIMER DISSIP    ******'
-        do i=0,mpi_size-1
-          print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
-     &            '  : temps moyen :',
-     &             timer_average(jj_nb_dissip(i),timer_dissip,i)
-        enddo
-        
-        print *,'*********************************'
-        print *,'******    TIMER PHYSIC    ******'
-        do i=0,mpi_size-1
-          print *,'proc',i,' :   Nb Bandes  :',jj_nb_physic(i),
-     &            '  : temps moyen :',
-     &             timer_average(jj_nb_physic(i),timer_physic,i)
-        enddo
-        
-      endif  
-      CALL barrier
-      print *,'Taille du Buffer MPI (REAL*8)',MaxBufferSize
+         call allgather_timer_average
+         call barrier
+         if (mpi_rank==0) then
+            
+            print *,'*********************************'
+            print *,'******    TIMER CALDYN     ******'
+            do i=0,mpi_size-1
+               print *,'proc',i,' :   Nb Bandes  :',jj_nb_caldyn(i),
+     &              '  : temps moyen :',
+     &              timer_average(jj_nb_caldyn(i),timer_caldyn,i)
+            enddo
+            
+            print *,'*********************************'
+            print *,'******    TIMER VANLEER    ******'
+            do i=0,mpi_size-1
+               print *,'proc',i,' :   Nb Bandes  :',jj_nb_vanleer(i),
+     &              '  : temps moyen :',
+     &              timer_average(jj_nb_vanleer(i),timer_vanleer,i)
+            enddo
+            
+            print *,'*********************************'
+            print *,'******    TIMER DISSIP    ******'
+            do i=0,mpi_size-1
+               print *,'proc',i,' :   Nb Bandes  :',jj_nb_dissip(i),
+     &              '  : temps moyen :',
+     &              timer_average(jj_nb_dissip(i),timer_dissip,i)
+            enddo
+            
+            print *,'*********************************'
+            print *,'******    TIMER PHYSIC    ******'
+            do i=0,mpi_size-1
+               print *,'proc',i,' :   Nb Bandes  :',jj_nb_physic(i),
+     &              '  : temps moyen :',
+     &              timer_average(jj_nb_physic(i),timer_physic,i)
+            enddo
+            
+         endif  
+         CALL barrier
+         print *,'Taille du Buffer MPI (REAL*8)',MaxBufferSize
       print *,'Taille du Buffer MPI utilise (REAL*8)',MaxBufferSize_Used
-      print *, 'Temps total ecoule sur la parallelisation :',DiffTime()
+       print *, 'Temps total ecoule sur la parallelisation :',DiffTime()
       print *, 'Temps CPU ecoule sur la parallelisation :',DiffCpuTime()
-      CALL print_filtre_timer
-c$OMP END MASTER
-      CALL dynredem1_loc("restart.nc",0.0,
-     .                               vcov,ucov,teta,q,masse,ps)
-c$OMP MASTER
-      call fin_getparam
-        call finalize_parallel
-c$OMP END MASTER
-c$OMP BARRIER
-        RETURN
+         CALL print_filtre_timer
+c$OMP END MASTER
+         CALL dynredem1_loc("restart.nc",0.0,
+     .        vcov,ucov,teta,q,masse,ps)
+c$OMP MASTER
+         call fin_getparam
+c$OMP END MASTER
+
+#ifdef INCA
+         call finalize_inca
+#endif
+
+c$OMP MASTER
+         call finalize_parallel
+c$OMP END MASTER
+c$OMP BARRIER
+         RETURN
       ENDIF
       
@@ -1482,4 +1489,11 @@
 c$OMP MASTER
               call fin_getparam
+c$OMP END MASTER
+
+#ifdef INCA
+              call finalize_inca
+#endif
+
+c$OMP MASTER
               call finalize_parallel
 c$OMP END MASTER
@@ -1604,4 +1618,11 @@
 c$OMP MASTER
                  call fin_getparam
+c$OMP END MASTER
+
+#ifdef INCA
+                 call finalize_inca
+#endif
+
+c$OMP MASTER
                  call finalize_parallel
 c$OMP END MASTER
@@ -1668,4 +1689,11 @@
 c$OMP MASTER
       call fin_getparam
+c$OMP END MASTER
+
+#ifdef INCA
+      call finalize_inca
+#endif
+
+c$OMP MASTER
       call finalize_parallel
 c$OMP END MASTER
Index: LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/gcm.F
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/gcm.F	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/gcm.F	(revision 2381)
@@ -246,5 +246,5 @@
      $        iphysiq,day_step,nday, 
      $        nbsrf, is_oce,is_sic,
-     $        is_ter,is_lic)
+     $        is_ter,is_lic, calend)
 
          call init_inca_para(
Index: LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/leapfrog_p.F	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/dyn3dpar/leapfrog_p.F	(revision 2381)
@@ -1410,5 +1410,10 @@
 c$OMP MASTER
               call fin_getparam
-              call finalize_parallel
+c$OMP END MASTER
+#ifdef INCA
+                 call finalize_inca
+#endif
+c$OMP MASTER
+               call finalize_parallel
 c$OMP END MASTER
               abort_message = 'Simulation finished'
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phys_output_write_mod.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phys_output_write_mod.F90	(revision 2381)
@@ -230,5 +230,5 @@
     USE ocean_slab_mod, only: tslab, slab_bils
     USE indice_sol_mod, only: nbsrf
-    USE infotrac, only: nqtot, nqo
+    USE infotrac, only: nqtot, nqo, type_trac
     USE comgeomphy, only: airephy
     USE surface_data, only: type_ocean, ok_veget, ok_snow
@@ -1427,4 +1427,5 @@
         IF (nqtot.GE.nqo+1) THEN
             DO iq=nqo+1,nqtot
+              IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
 
              CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
@@ -1449,4 +1450,5 @@
              ENDIF
              CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             endif
           ENDDO
        ENDIF
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/physiq.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/physiq.F90	(revision 2381)
@@ -1307,5 +1307,9 @@
              annee_ref, &
              day_ref,  &
-             itau_phy)
+             day_ini, &
+             start_time, &
+             itau_phy, &
+             io_lon, &
+             io_lat)
 
         CALL VTe(VTinca)
@@ -2989,5 +2993,5 @@
      calday = REAL(days_elapsed + 1) + jH_cur
 
-     call chemtime(itap+itau_phy-1, date0, dtime)
+     call chemtime(itap+itau_phy-1, date0, dtime, itap)
      IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
         CALL AEROSOL_METEO_CALC( &
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phytrac_mod.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/phytrac_mod.F90	(revision 2381)
@@ -308,5 +308,4 @@
 !$OMP THREADPRIVATE(lessivage)
 
-    CHARACTER(len=8),DIMENSION(nbtr) :: solsym
     !RomP >>>
     INTEGER,SAVE  :: iflag_lscav_omp,iflag_lscav
@@ -557,5 +556,5 @@
             cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon,iflag_vdf_trac>=0,sh, &
             rh, pphi, ustar, wstar, ale_bl, ale_wake,  u10m, v10m, &
-            tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
+            tr_seri, source, d_tr_cl,d_tr_dec, zmasse)               !RomP
 
     CASE('inca')
@@ -572,5 +571,5 @@
             tau_aero, piz_aero, cg_aero,        ccm,       &
             rfname,                                        &
-            tr_seri,  source,   solsym)      
+            tr_seri,  source)      
 
     CASE('repr')
@@ -580,5 +579,5 @@
             presnivs, xlat, xlon, pphis, pphi, &
             t_seri, pplay, paprs, sh , &
-            tr_seri, solsym)
+            tr_seri)
 
     END SELECT
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2381)
@@ -84,6 +84,5 @@
   REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer
   REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer_pi !RAF  
-  !  REAL, DIMENSION(klon,naero_tot)      :: fractnat_allaer !RAF delete??
-  character(len=8), dimension(nbtr) :: tracname
+
   integer :: id_ASBCM, id_ASPOMM, id_ASSO4M, id_ASMSAM, id_CSSO4M, id_CSMSAM, id_SSSSM
   integer :: id_CSSSM, id_ASSSM, id_CIDUSTM, id_AIBCM, id_AIPOMM, id_ASNO3M, id_CSNO3M, id_CINO3M
@@ -104,10 +103,6 @@
      !--convert to ug m-3 unit for consistency with offline fields
      !
-#ifdef INCA
-     call tracinca_name(tracname)
-#endif
-
      do i=1,nbtr
-        select case(trim(tracname(i)))
+        select case(trim(solsym(i)))
            case ("ASBCM")
               id_ASBCM = i
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracinca_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracinca_mod.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracinca_mod.F90	(revision 2381)
@@ -35,5 +35,5 @@
        tau_aero, piz_aero, cg_aero,        ccm,       &
        rfname,                                        &
-       tr_seri,  source,   solsym)      
+       tr_seri,  source)      
 
 !========================================================
@@ -113,5 +113,4 @@
   ! Output arguments
     REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
 
 !=======================================================================================
@@ -134,30 +133,20 @@
        pdel(:,k) = paprs(:,k) - paprs (:,k+1)
     END DO
-    
-    zpmfu(:,:)=pmfu(:,:)
+  
+#ifdef INCA
+    IF (config_inca == 'aero') THEN 
+       zpmfu(:,:)=pmfu(:,:)       
+    ELSE IF (config_inca == 'aeNP') THEN
+       zpmfu(:,:)=upwd(:,:)
+    ENDIF
 
-    IF (config_inca == 'aero') THEN
-#ifdef INCA
-       CALL aerosolmain(                    &
-            aerosol_couple,tr_seri,pdtphys, &
-            pplay,pdel,prfl,pmflxr,psfl,    &
-            pmflxs,zpmfu,itop_con,ibas_con,  &
-            pphi,airephy,nstep,rneb,t_seri, &      
-            rh,tau_aero,piz_aero,cg_aero,   &
-            rfname,ccm,lafin)
+    CALL aerosolmain(                    &
+         aerosol_couple,tr_seri,pdtphys, &
+         pplay,pdel,prfl,pmflxr,psfl,    &
+         pmflxs,zpmfu,itop_con,ibas_con,  &
+         pphi,airephy,nstep,rneb,t_seri, &      
+         rh,tau_aero,piz_aero,cg_aero,   &
+         rfname,ccm,lafin, config_inca)
 #endif
-    END IF
-
-    IF (config_inca == 'aeNP') THEN
-#ifdef INCA
-       zpmfu(:,:)=upwd(:,:)
-       CALL aerosolmainNP(                  &
-            aerosol_couple,tr_seri,pdtphys, &
-            pplay,pdel,prfl,pmflxr,psfl,    &
-            pmflxs,zpmfu,itop_con,ibas_con,  &
-            pphi,airephy,nstep,rneb,t_seri, &      
-            rh,lafin)
-#endif
-    END IF
 
 
@@ -196,6 +185,5 @@
          iip1,       & !nx
          jjp1,       & !ny
-         source,     &
-         solsym)
+         source )
 #endif
     
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/traclmdz_mod.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/traclmdz_mod.F90	(revision 2381)
@@ -338,6 +338,5 @@
        cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, sh, &
        rh, pphi, ustar, wstar, ale_bl, ale_wake,  zu10m, zv10m, &
-!!          tr_seri, source, solsym, d_tr_cl, zmasse)                      !RomP
-          tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
+       tr_seri, source, d_tr_cl,d_tr_dec, zmasse)               !RomP
     
     USE dimphy
@@ -397,5 +396,4 @@
 
 ! Output argument
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
     REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
     REAL,DIMENSION(klon,klev,nbtr), INTENT(OUT)   :: d_tr_cl ! Td couche limite/traceur
Index: LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracreprobus_mod.F90	(revision 2316)
+++ LMDZ5/branches/LMDZ6_rc0/libf/phylmd/tracreprobus_mod.F90	(revision 2381)
@@ -9,5 +9,5 @@
        presnivs, xlat, xlon, pphis, pphi, &
        t_seri, pplay, paprs, sh , &
-       tr_seri, solsym)
+       tr_seri)
 
     USE dimphy
@@ -42,5 +42,4 @@
 !----------------
     REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]  
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
   
 