Index: LMDZ5/trunk/libf/dynlonlat_phylonlat/phymar/iniphysiq_mod.F90
===================================================================
--- LMDZ5/trunk/libf/dynlonlat_phylonlat/phymar/iniphysiq_mod.F90	(revision 2372)
+++ LMDZ5/trunk/libf/dynlonlat_phylonlat/phymar/iniphysiq_mod.F90	(revision 2383)
@@ -6,5 +6,5 @@
 CONTAINS
 
-SUBROUTINE iniphysiq(iim,jjm,nlayer,
+SUBROUTINE iniphysiq(ii,jj,nlayer, &
                      nbp, communicator, &
                      punjours, pdayref,ptimestep, &
@@ -19,4 +19,5 @@
                                 klon_mpi_begin ! start indes of columns (on local mpi grid)
   USE geometry_mod, ONLY : init_geometry
+  USE infotrac, ONLY: nqtot
   USE comcstphy, ONLY: rradius, & ! planet radius (m)
                        rr, & ! recuced gas constant: R/molar mass of atm
@@ -30,4 +31,5 @@
                                  south_west, south_east
   USE mod_interface_dyn_phys, ONLY :  init_interface_dyn_phys
+  USE infotrac_phy, ONLY: init_infotrac_phy
   USE nrtype, ONLY: pi
   IMPLICIT NONE
@@ -47,15 +49,15 @@
   REAL,INTENT(IN) :: punjours ! length (in s) of a standard day
   INTEGER, INTENT (IN) :: nlayer ! number of atmospheric layers
-  INTEGER, INTENT (IN) :: iim ! number of atmospheric coulumns along longitudes
-  INTEGER, INTENT (IN) :: jjm  ! number of atompsheric columns along latitudes
+  INTEGER, INTENT (IN) :: ii ! number of atmospheric coulumns along longitudes
+  INTEGER, INTENT (IN) :: jj  ! number of atompsheric columns along latitudes
   INTEGER, INTENT(IN) :: nbp ! number of physics columns for this MPI process
   INTEGER, INTENT(IN) :: communicator ! MPI communicator
-  REAL, INTENT (IN) :: rlatu(jjm+1) ! latitudes of the physics grid
-  REAL, INTENT (IN) :: rlatv(jjm) ! latitude boundaries of the physics grid
-  REAL, INTENT (IN) :: rlonv(iim+1) ! longitudes of the physics grid
-  REAL, INTENT (IN) :: rlonu(iim+1) ! longitude boundaries of the physics grid
-  REAL, INTENT (IN) :: aire(iim+1,jjm+1) ! area of the dynamics grid (m2)
-  REAL, INTENT (IN) :: cu((iim+1)*(jjm+1)) ! cu coeff. (u_covariant = cu * u)
-  REAL, INTENT (IN) :: cv((iim+1)*jjm) ! cv coeff. (v_covariant = cv * v)
+  REAL, INTENT (IN) :: rlatu(jj+1) ! latitudes of the physics grid
+  REAL, INTENT (IN) :: rlatv(jj) ! latitude boundaries of the physics grid
+  REAL, INTENT (IN) :: rlonv(ii+1) ! longitudes of the physics grid
+  REAL, INTENT (IN) :: rlonu(ii+1) ! longitude boundaries of the physics grid
+  REAL, INTENT (IN) :: aire(ii+1,jj+1) ! area of the dynamics grid (m2)
+  REAL, INTENT (IN) :: cu((ii+1)*(jj+1)) ! cu coeff. (u_covariant = cu * u)
+  REAL, INTENT (IN) :: cv((ii+1)*jj) ! cv coeff. (v_covariant = cv * v)
   INTEGER, INTENT (IN) :: pdayref ! reference day of for the simulation
   REAL,INTENT(IN) :: ptimestep !physics time step (s)
@@ -97,8 +99,8 @@
   
   ! init regular global longitude-latitude grid points and boundaries
-  ALLOCATE(boundslon_reg(iim,2))
-  ALLOCATE(boundslat_reg(jjm+1,2))
+  ALLOCATE(boundslon_reg(ii,2))
+  ALLOCATE(boundslat_reg(jj+1,2))
   
-  DO i=1,iim
+  DO i=1,ii
    boundslon_reg(i,east)=rlonu(i) 
    boundslon_reg(i,west)=rlonu(i+1) 
@@ -107,13 +109,13 @@
   boundslat_reg(1,north)= PI/2 
   boundslat_reg(1,south)= rlatv(1)
-  DO j=2,jjm
+  DO j=2,jj
    boundslat_reg(j,north)=rlatv(j-1) 
    boundslat_reg(j,south)=rlatv(j) 
   ENDDO
-  boundslat_reg(jjm+1,north)= rlatv(jjm) 
-  boundslat_reg(jjm+1,south)= -PI/2
+  boundslat_reg(jj+1,north)= rlatv(jj) 
+  boundslat_reg(jj+1,south)= -PI/2
 
   ! Write values in module regular_lonlat_mod
-  CALL init_regular_lonlat(iim,jjm+1, rlonv(1:iim), rlatu, &
+  CALL init_regular_lonlat(ii,jj+1, rlonv(1:ii), rlatu, &
                            boundslon_reg, boundslat_reg)
 
@@ -139,11 +141,11 @@
     boundslonfi_glo(1,south_east)=0
     boundslatfi_glo(1,south_east)=rlatv(1)
-    DO j=2,jjm
-      DO i=1,iim
-        k=(j-2)*iim+1+i
-        latfi_glo((j-2)*iim+1+i)= rlatu(j)
-        lonfi_glo((j-2)*iim+1+i)= rlonv(i)
-        cufi_glo((j-2)*iim+1+i) = cu((j-1)*iim+1+i)
-        cvfi_glo((j-2)*iim+1+i) = cv((j-1)*iim+1+i)
+    DO j=2,jj
+      DO i=1,ii
+        k=(j-2)*ii+1+i
+        latfi_glo((j-2)*ii+1+i)= rlatu(j)
+        lonfi_glo((j-2)*ii+1+i)= rlonv(i)
+        cufi_glo((j-2)*ii+1+i) = cu((j-1)*ii+1+i)
+        cvfi_glo((j-2)*ii+1+i) = cv((j-1)*ii+1+i)
         boundslonfi_glo(k,north_east)=rlonu(i)
         boundslatfi_glo(k,north_east)=rlatv(j-1)
@@ -157,12 +159,12 @@
     ENDDO
     ! South pole
-    latfi_glo(klon_glo)= rlatu(jjm+1)
+    latfi_glo(klon_glo)= rlatu(jj+1)
     lonfi_glo(klon_glo)= 0.
-    cufi_glo(klon_glo) = cu((iim+1)*jjm+1)
-    cvfi_glo(klon_glo) = cv((iim+1)*jjm-iim)
+    cufi_glo(klon_glo) = cu((ii+1)*jj+1)
+    cvfi_glo(klon_glo) = cv((ii+1)*jj-ii)
     boundslonfi_glo(klon_glo,north_east)= 0
-    boundslatfi_glo(klon_glo,north_east)= rlatv(jjm)
+    boundslatfi_glo(klon_glo,north_east)= rlatv(jj)
     boundslonfi_glo(klon_glo,north_west)= 2*PI
-    boundslatfi_glo(klon_glo,north_west)= rlatv(jjm)
+    boundslatfi_glo(klon_glo,north_west)= rlatv(jj)
     boundslonfi_glo(klon_glo,south_west)= 2*PI
     boundslatfi_glo(klon_glo,south_west)= -PI/2
@@ -171,11 +173,11 @@
 
     ! build airefi(), mesh area on physics grid
-    CALL gr_dyn_fi(1,iim+1,jjm+1,klon_glo,aire,airefi_glo)
+    CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,aire,airefi_glo)
     ! Poles are single points on physics grid
-    airefi_glo(1)=sum(aire(1:iim,1))
-    airefi_glo(klon_glo)=sum(aire(1:iim,jjm+1))
+    airefi_glo(1)=sum(aire(1:ii,1))
+    airefi_glo(klon_glo)=sum(aire(1:ii,jj+1))
 
     ! Sanity check: do total planet area match between physics and dynamics?
-    total_area_dyn=sum(aire(1:iim,1:jjm+1))
+    total_area_dyn=sum(aire(1:ii,1:jj+1))
     total_area_phy=sum(airefi_glo(1:klon_glo))
     IF (total_area_dyn/=total_area_phy) THEN
@@ -228,4 +230,7 @@
 
 
+  ! Initialize tracer names, numbers, etc. for physics
+  CALL init_infotrac_phy(nqtot)
+
 ! copy some fundamental parameters to physics
   rradius=prad